#include  <Trade\Trade.mqh>
CTrade Trade;

//Externe Variabeln
input double Lot=0.1;
input int TakeProfit=80;
input int StopLoss=40;

input bool UseCandleTrail=true;
input int CandleBack=6;
input int PadAmount=5;

input int ma_fast_period=20;
input int ma_fast_shift=0;
input ENUM_MA_METHOD ma_fast_method=MODE_EMA;
input ENUM_APPLIED_PRICE fast_applied_price=PRICE_CLOSE;

input int ma_slow_period=40;
input int ma_slow_shift=0;
input ENUM_MA_METHOD ma_slow_method=MODE_EMA;
input ENUM_APPLIED_PRICE slow_applied_price=PRICE_CLOSE;

//Interne Variablen
int ma_fast_handle; double ma_fast[];
int ma_slow_handle; double ma_slow[];
double point;

double low[],high[];
double LowestLow,HighestHigh;

int OnInit()
  {  
   ma_fast_handle = iMA(NULL,0,ma_fast_period,ma_fast_shift,ma_fast_method,fast_applied_price);
   ma_slow_handle = iMA(NULL,0,ma_slow_period,ma_slow_shift,ma_slow_method,slow_applied_price);
   
   if(_Digits==5 || _Digits==3)
      {point = _Point*10;}
      else
      {point = _Point;}
   
   return(INIT_SUCCEEDED);
  }

void OnDeinit(const int reason)
  {
   IndicatorRelease(ma_fast_handle); 
   IndicatorRelease(ma_slow_handle);
  }

void OnTick()
  {
   
   //LowestLow & HighestHigh  
   ArraySetAsSeries(low,true);
   ArraySetAsSeries(high,true);
   CopyLow(_Symbol,_Period,1,CandleBack,low);
   CopyHigh(_Symbol,_Period,1,CandleBack,high);
   int Lowest = ArrayMinimum(low,1,CandleBack);
   int Highest = ArrayMaximum(high,1,CandleBack);
   LowestLow = low[Lowest];
   HighestHigh = high[Highest];
    
   ArraySetAsSeries(ma_fast,true);
   ArraySetAsSeries(ma_slow,true);
   CopyBuffer(ma_fast_handle,0,0,3,ma_fast);
   CopyBuffer(ma_slow_handle,0,0,3,ma_slow);
  
   //Entry Conditions
   bool BuyCondition  =(ma_fast[1]>ma_slow[1] && ma_fast[2]<ma_slow[2]);
   bool SellCondition =(ma_fast[1]<ma_slow[1] && ma_fast[2]>ma_slow[2]);
   
   //Place Buy Order
   if(BuyCondition)
      if(!PositionSelect(_Symbol))
         {
         double Ask = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
			Trade.PositionOpen(
   			_Symbol,
   			ORDER_TYPE_BUY,
   			Lot,
   			Ask,
   			NormalizeDouble(Ask- StopLoss*point,_Digits),
   			NormalizeDouble(Ask+ TakeProfit*point,_Digits));
         }
   
   //Place Sell Order
   if(SellCondition)
      if(!PositionSelect(_Symbol))
         {
         double Bid = SymbolInfoDouble(_Symbol,SYMBOL_BID);
			Trade.PositionOpen(
   			_Symbol,
   			ORDER_TYPE_SELL,
   			Lot,
   			Bid,
   			NormalizeDouble(Bid+ StopLoss*point,_Digits),
   			NormalizeDouble(Bid- TakeProfit*point,_Digits));
         }
   
   //CandleTrail
   if(PositionSelect(_Symbol) == true && UseCandleTrail == true)candletrail(CandleBack,PadAmount);

   };
      


//CandleTrail Funktion
void candletrail(double CBack, double PAmount)
      {
      MqlTradeRequest request;
      MqlTradeResult result;   
      ZeroMemory(request);
      ZeroMemory(result);
      
      PAmount = PAmount*point;
      
      request.action = TRADE_ACTION_SLTP;
      request.symbol = _Symbol;
      request.tp = PositionGetDouble(POSITION_TP);
      
      long type = PositionGetInteger(POSITION_TYPE);
      double currentSL = PositionGetDouble(POSITION_SL);
      double openPrice = PositionGetDouble(POSITION_PRICE_OPEN);
      
      double CandleTrailPrice; 
      
      if(type == POSITION_TYPE_BUY)
         {
         CandleTrailPrice = LowestLow - PAmount;
         double Ask = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
         if(CandleTrailPrice > currentSL)
            {
            request.sl = CandleTrailPrice;
            OrderSend(request,result);
            }
         }
         
      else if(type == POSITION_TYPE_SELL)
         {
         CandleTrailPrice = HighestHigh + PAmount;
         double Bid = SymbolInfoDouble(_Symbol,SYMBOL_BID);
         if(CandleTrailPrice < currentSL)
            {
            request.sl = CandleTrailPrice;
            OrderSend(request,result);
            }
         }
         
      }

